You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.
 
 

114 lines
2.4 KiB

#!/bin/bash
## compose: no-hooks
if [ -z "$SERVICE_DATASTORE" ]; then
echo "This script is meant to be run through 'compose' to work properly." >&2
exit 1
fi
. $CHARM_PATH/lib/common
version=0.1
usage="$exname [-h|--help]"
help="
USAGE:
$usage
DESCRIPTION:
Request an invite code.
EXAMPLES:
$exname
"
dbname=
neutralize=
while [ "$1" ]; do
case "$1" in
"--help"|"-h")
print_help >&2
exit 0
;;
--*|-*)
err "Unexpected optional argument '$1'"
print_usage >&2
exit 1
;;
*)
err "Unexpected positional argument '$1'"
print_usage >&2
exit 1
;;
esac
shift
done
set -e
. "$PDS_ENV_FILE"
curl_opts=()
service_def=$(get_compose_service_def "$SERVICE_NAME")
containers="$(get_running_containers_for_service "$SERVICE_NAME")"
if [ -z "$containers" ]; then
err "No containers running for service $DARKYELLOW$SERVICE_NAME$NORMAL."
exit 1
fi
if [ "$(echo "$containers" | wc -l)" -gt 1 ]; then
err "More than 1 container running for service $DARKYELLOW$SERVICE_NAME$NORMAL."
echo " Please contact administrator to fix this issue." >&2
exit 1
fi
container="$(echo "$containers" | head -n 1)"
container_network_ip=$(get_healthy_container_ip_for_service "$SERVICE_NAME" 3000 4) || {
err "Please ensure that $DARKYELLOW$service$NORMAL is running before using '$exname'."
exit 1
}
container_ip=${container_network_ip##*:}
container_network=${container_network_ip%%:*}
DEFAULT_CURL_IMAGE=${DEFAULT_CURL_IMAGE:-docker.0k.io/curl}
cmd=(
docker run -i --rm --network "$container_network"
"$DEFAULT_CURL_IMAGE"
--fail \
--silent \
--show-error \
--request POST \
--user "admin:${PDS_ADMIN_PASSWORD}" \
--header "Content-Type: application/json" \
--data '{"useCount": 1}' \
"http://${container_ip}:3000/xrpc/com.atproto.server.createInviteCode"
)
## XXXvlab: contains password, left only for advanced debug
#echo "COMMAND: ${cmd[@]}" >&2
if ! out=$("${cmd[@]}"); then
err "Failed to request an invite code."
echo " $out" | prefix " $GRAY|$NORMAL " >&2
exit 1
fi
e "$out" | jq -r '.code' || {
err "Failed to parse invite code from response."
echo " $out" | prefix " $GRAY|$NORMAL " >&2
exit 1
}